* stor-layout.c (layout_type): Do upper - lower in the native type,
[official-gcc.git] / configure.in
blobbec2b3486ebe466657a0631f10f973ff05eb50da
1 #! /bin/bash
2 ##############################################################################
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
17 # Copyright (C) 1992, 93, 94, 95, 96, 1997 Free Software Foundation, Inc.
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
33 ##############################################################################
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
42 # these libraries are used by various programs built for the host environment
44 host_libs="mmalloc libiberty opcodes bfd readline gash db tcl tk tclX itcl tix"
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
50 # these tools are built for the host environment
51 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
52 # know that we are building the simulator.
53 host_tools="texinfo byacc flex bison binutils ld gas gcc sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu bash m4 autoconf automake ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils sn"
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
68 target_tools="target-examples target-groff target-gperf"
70 ################################################################################
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
78 # directories to be built in the native environment only
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf automake cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms sn gnuserv target-gperf"
84 # directories to be built in a cross environment only
86 cross_only="target-libgloss target-newlib"
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
97 ################################################################################
99 srctrigger=move-if-change
100 srcname="gnu development package"
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
105 # per-host:
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3*) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 i[3456]86-*-msdosdjgpp*) host_makefile_frag=config/mh-go32 ;;
134 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
135 *-windows*) host_makefile_frag=config/mh-windows ;;
136 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
137 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
138 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
139 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
140 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
141 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
142 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
143 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
144 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
145 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
146 esac
149 # If we aren't going to be using gcc, see if we can extract a definition
150 # of CC from the fragment.
151 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
152 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
153 found=
154 for dir in $PATH; do
155 test -z "$dir" && dir=.
156 if test -f $dir/gcc; then
157 found=yes
158 break
160 done
161 IFS="$save_ifs"
162 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
163 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
164 if [ -n "${xx}" ] ; then
165 CC=$xx
170 # We default to --with-shared on platforms where -fpic is meaningless.
171 # Well, we don't yet, but we will.
172 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
173 case "${target}" in
174 alpha-dec-osf*) enable_shared=yes ;;
175 alpha-*-linux*) enable_shared=yes ;;
176 mips-sgi-irix5*) enable_shared=yes ;;
177 *) enable_shared=no ;;
178 esac
181 case "${enable_shared}" in
182 yes) shared=yes ;;
183 no) shared=no ;;
184 "") shared=no ;;
185 *) shared=yes ;;
186 esac
188 if [ x${shared} = xyes ]; then
189 waugh=
190 case "${host}" in
191 hppa*) waugh=config/mh-papic ;;
192 i[3456]86-*) waugh=config/mh-x86pic ;;
193 sparc64-*) waugh=config/mh-sparcpic ;;
194 powerpc*-*) waugh=config/mh-ppcpic ;;
195 alpha-*-linux*) waugh=config/mh-elfalphapic ;;
196 *) waugh=config/mh-${host_cpu}pic ;;
197 esac
198 if [ -f ${srcdir}/${waugh} ]; then
199 if [ -n "${host_makefile_frag}" ] ; then
200 cat ${srcdir}/${host_makefile_frag} > mh-frag
201 cat ${srcdir}/${waugh} >> mh-frag
202 host_makefile_frag=mh-frag
203 else
204 host_makefile_frag=${waugh}
209 # per-target:
211 case "${target}" in
212 v810*) target_makefile_frag=config/mt-v810 ;;
213 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
214 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
215 *-*-linux-gnu) target_makefile_frag=config/mt-linux ;;
216 esac
218 skipdirs=
219 gasdir=gas
220 use_gnu_ld=
221 use_gnu_as=
223 # some tools are so dependent upon X11 that if we're not building with X,
224 # it's not even worth trying to configure, much less build, that tool.
226 case ${with_x} in
227 yes | "") # the default value for this tree is that X11 is available
230 skipdirs="${skipdirs} tk gash"
233 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
235 esac
237 # Some tools are only suitable for building in a "native" situation.
238 # Those are added when we have a host==target configuration. For cross
239 # toolchains, we add some directories that should only be useful in a
240 # cross-compiler.
242 is_cross_compiler=
244 if [ x"${host}" = x"${target}" ] ; then
245 # when doing a native toolchain, don't build the targets
246 # that are in the 'cross only' list
247 skipdirs="${skipdirs} ${cross_only}"
248 is_cross_compiler=no
249 # Default to --enable-multilib. See similar code below.
250 if [ x${enable_multilib} = xno ]; then
251 target_subdir=.
252 else
253 target_subdir=libraries
255 else
256 # similarly, don't build the targets in the 'native only'
257 # list when building a cross compiler
258 skipdirs="${skipdirs} ${native_only}"
259 is_cross_compiler=yes
260 target_subdir=${target_alias}
263 if [ ! -d ${target_subdir} ] ; then
264 if mkdir ${target_subdir} ; then true
265 else
266 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
267 exit 1
271 copy_dirs=
273 # Handle --with-headers=XXX. The contents of the named directory are
274 # copied to $(tooldir)/sys-include.
275 if [ x"${with_headers}" != x ]; then
276 if [ x${is_cross_compiler} = xno ]; then
277 echo 1>&2 '***' --with-headers is only supported when cross compiling
278 exit 1
280 case "${exec_prefixoption}" in
281 "") x=${prefix} ;;
282 *) x=${exec_prefix} ;;
283 esac
284 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
287 # Handle --with-libs=XXX. Multiple directories are permitted. The
288 # contents are copied to $(tooldir)/lib.
289 if [ x"${with_libs}" != x ]; then
290 if [ x${is_cross_compiler} = xno ]; then
291 echo 1>&2 '***' --with-libs is only supported when cross compiling
292 exit 1
294 # Copy the libraries in reverse order, so that files in the first named
295 # library override files in subsequent libraries.
296 case "${exec_prefixoption}" in
297 "") x=${prefix} ;;
298 *) x=${exec_prefix} ;;
299 esac
300 for l in ${with_libs}; do
301 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
302 done
305 # If both --with-headers and --with-libs are specified, default to
306 # --without-newlib.
307 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
308 if [ x"${with_newlib}" = x ]; then
309 with_newlib=no
313 # Recognize --with-newlib/--without-newlib.
314 if [ x${with_newlib} = xno ]; then
315 skipdirs="${skipdirs} target-newlib"
316 elif [ x${with_newlib} = xyes ]; then
317 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
320 # Default to using --with-stabs for certain targets.
321 if [ x${with_stabs} = x ]; then
322 case "${target}" in
323 mips*-*-irix6*)
325 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
326 with_stabs=yes;
327 withoptions="${withoptions} --with-stabs"
329 esac
332 # Handle ${copy_dirs}
333 set fnord ${copy_dirs}
334 shift
335 while [ $# != 0 ]; do
336 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
338 else
339 echo Copying $1 to $2
341 # Use the install script to create the directory and all required
342 # parent directories.
343 if [ -d $2 ]; then
345 else
346 echo >config.temp
347 ${srcdir}/install-sh -c -m 644 config.temp $2/COPIED
350 # Copy the directory, assuming we have tar.
351 # FIXME: Should we use B in the second tar? Not all systems support it.
352 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
354 # It is the responsibility of the user to correctly adjust all
355 # symlinks. If somebody can figure out how to handle them correctly
356 # here, feel free to add the code.
358 echo $1 > $2/COPIED
360 shift; shift
361 done
363 # Configure extra directories which are host specific
365 case "${host}" in
366 i[3456]86-*-go32*)
367 configdirs="$configdirs dosrel" ;;
368 *-cygwin32*)
369 configdirs="$configdirs dosrel" ;;
370 esac
372 # Remove more programs from consideration, based on the host or
373 # target this usually means that a port of the program doesn't
374 # exist yet.
376 noconfigdirs=""
378 case "${host}" in
379 i[3456]86-*-vsta)
380 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl tix db sn gnuserv"
382 i[3456]86-*-go32* | i[3456]86-*-msdosdjgpp*)
383 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr uudecode dejagnu diff guile perl apache inet itcl tix db sn gnuserv"
385 *-*-cygwin32)
386 noconfigdirs="expect dejagnu cvs autoconf automake bison send-pr gprof rcs guile perl texinfo apache inet"
388 *-*-windows*)
389 # This is only used to build WinGDB...
390 # note that powerpc-eabi depends on sim configured before gdb.
391 configdirs="bfd libiberty opcodes readline sim gdb"
392 target_configdirs=
394 ppc*-*-pe)
395 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf automake texinfo bison send-pr gprof rcs guile perl apache inet itcl tix db sn gnuserv"
397 esac
400 case "${target}" in
401 *-*-netware)
402 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
404 *-*-rtems*)
405 noconfigdirs="$noconfigdirs target-libgloss"
407 *-*-vxworks*)
408 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
410 alpha-dec-osf*)
411 # ld works, but does not support shared libraries. emacs doesn't
412 # work. newlib is not 64 bit ready. I'm not sure about fileutils.
413 # gas doesn't generate exception information.
414 noconfigdirs="$noconfigdirs gas ld emacs fileutils target-newlib target-libgloss"
416 alpha*-*-*vms*)
417 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
419 alpha*-*-*)
420 # newlib is not 64 bit ready
421 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
423 arc-*-*)
424 noconfigdirs="$noconfigdirs target-libgloss"
426 arm-*-pe*)
427 noconfigdirs="$noconfigdirs target-libgloss"
429 arm-*-coff*)
430 noconfigdirs="$noconfigdirs target-libgloss"
432 arm-*-riscix*)
433 noconfigdirs="$noconfigdirs ld target-libgloss"
435 d10v-*-*)
436 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
438 h8300*-*-* | \
439 h8500-*-*)
440 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
442 hppa*-*-*elf* | \
443 hppa*-*-lites*)
444 # Do configure ld/binutils/gas for this case.
446 hppa*-*-*)
447 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
448 # cc is gcc, and on any system a user should be able to link cc to
449 # whatever they want. FIXME, emacs emacs19).
450 case "${CC}" in
451 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
452 *) ;;
453 esac
454 noconfigdirs="$noconfigdirs ld shellutils"
456 i[3456]86-*-go32* | i[3456]-*-msdosdjgpp*)
457 # but don't build gdb
458 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
460 *-*-linux*)
461 # linux has rx in libc
462 skipdirs="$skipdirs target-librx"
464 *-*-cygwin32)
465 target_configdirs="$target_configdirs target-winsup"
466 noconfigdirs="$noconfigdirs expect target-libgloss"
467 # always build newlib.
468 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
470 # Can't build gdb for cygwin32 if not native.
471 case "${host}" in
472 *-*-cygwin32) ;; # keep gdb tcl tk expect etc.
473 *) noconfigdirs="$noconfigdirs gdb tcl tk expect itcl tix db sn gnuserv"
475 esac
477 i[3456]86-*-pe)
478 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
480 i[3456]86-*-sco3.2v5*)
481 # The linker does not yet know about weak symbols in COFF,
482 # and is not configured to handle mixed ELF and COFF.
483 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
485 i[3456]86-*-sco*)
486 noconfigdirs="$noconfigdirs gprof target-libgloss"
488 i[3456]86-*-solaris2*)
489 # The linker does static linking correctly, but the Solaris C library
490 # has bugs such that some important functions won't work when statically
491 # linked. (See man pages for getpwuid, for example.)
492 noconfigdirs="$noconfigdirs ld target-libgloss"
494 i[3456]86-*-sysv4*)
495 # The SYSV4 C compiler doesn't handle Emacs correctly
496 case "${CC}" in
497 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
498 *) ;;
499 esac
500 # but that's okay since emacs doesn't work anyway
501 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
503 mn10200-*-*)
504 noconfigdirs="$noconfigdirs target-libgloss"
506 mn10300-*-*)
507 noconfigdirs="$noconfigdirs target-libgloss"
509 powerpc-*-aix*)
510 # copied from rs6000-*-* entry
511 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
512 # This is needed until gcc and ld are fixed to work together.
513 use_gnu_ld=no
515 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
516 target_configdirs="$target_configdirs target-winsup"
517 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl tix db sn gnuserv"
518 # always build newlib.
519 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
521 # This is temporary until we can link against shared libraries
522 powerpcle-*-solaris*)
523 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl tix db sn gnuserv"
525 rs6000-*-lynxos*)
526 # The CVS server code doesn't work on the RS/6000
527 # Newlib makes problems for libg++ in crosses.
528 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
530 rs6000-*-aix*)
531 noconfigdirs="$noconfigdirs gprof"
532 # This is needed until gcc and ld are fixed to work together.
533 use_gnu_ld=no
535 rs6000-*-*)
536 noconfigdirs="$noconfigdirs gprof"
538 m68k-apollo-*)
539 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
541 mips*-*-irix5*)
542 # The GNU linker does not support shared libraries.
543 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
544 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
546 mips*-*-irix6*)
547 # The GNU assembler and linker do not support IRIX 6.
548 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
549 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
551 mips*-dec-bsd*)
552 noconfigdirs="$noconfigdirs gprof target-libgloss"
554 mips*-*-bsd*)
555 noconfigdirs="$noconfigdirs gprof target-libgloss"
557 mips*-*-*)
558 noconfigdirs="$noconfigdirs gprof"
560 romp-*-*)
561 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
563 sh-*-*)
564 case "${host}" in
565 i[3456]86-*-vsta) ;; # don't add gprof back in
566 i[3456]86-*-go32*) ;; # don't add gprof back in
567 i[3456]86-*-msdosdjgpp*) ;; # don't add gprof back in
568 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
569 esac
570 noconfigdirs="$noconfigdirs target-libgloss"
572 sparc-*-sunos4*)
573 if [ x${is_cross_compiler} != xno ] ; then
574 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
575 else
576 use_gnu_ld=no
579 v810-*-*)
580 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
582 vax-*-vms)
583 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
585 vax-*-*)
586 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
588 *-*-lynxos*)
589 # Newlib makes problems for libg++ in crosses.
590 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
592 *-*-macos* | \
593 *-*-mpw*)
594 # Macs want a resource compiler.
595 configdirs="$configdirs grez"
597 esac
599 # targets that need a second pass
600 case "${target}" in
601 *-gm-magic*)
602 noconfigdirs="$noconfigdirs target-libgloss"
604 esac
606 # If we aren't building newlib, then don't build libgloss, since libgloss
607 # depends upon some newlib header files.
608 case "${noconfigdirs}" in
609 *target-libgloss*) ;;
610 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
611 esac
613 # If we are building a Canadian Cross, discard tools that can not be built
614 # using a cross compiler. FIXME: These tools should be fixed.
615 if [ "${build}" != "${host}" ]; then
616 noconfigdirs="$noconfigdirs expect dejagnu"
619 # Make sure we don't let GNU ld be added if we didn't want it.
620 if [ x$with_gnu_ld = xno ]; then
621 use_gnu_ld=no
622 noconfigdirs="$noconfigdirs ld"
625 # Make sure we don't let GNU as be added if we didn't want it.
626 if [ x$with_gnu_as = xno ]; then
627 use_gnu_as=no
628 noconfigdirs="$noconfigdirs gas"
631 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
632 # $target_configdirs.
633 # If we have the source for $noconfigdirs entries, add them to $notsupp.
635 notsupp=""
636 for dir in . $skipdirs $noconfigdirs ; do
637 dirname=`echo $dir | sed -e s/target-//g`
638 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
639 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
640 if [ -r $srcdir/$dirname/configure ] \
641 || [ -r $srcdir/$dirname/configure.in ]; then
642 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
643 true
644 else
645 notsupp="$notsupp $dir"
649 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
650 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
651 if [ -r $srcdir/$dirname/configure ] \
652 || [ -r $srcdir/$dirname/configure.in ]; then
653 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
654 true
655 else
656 notsupp="$notsupp $dir"
660 done
662 # Sometimes the tools are distributed with libiberty but with no other
663 # libraries. In that case, we don't want to build target-libiberty.
664 if [ -n "${target_configdirs}" ]; then
665 others=
666 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
667 if [ "$i" != "libiberty" ]; then
668 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
669 others=yes;
670 break;
673 done
674 if [ -z "${others}" ]; then
675 target_configdirs=
679 # Deconfigure all subdirectories, in case we are changing the
680 # configuration from one where a subdirectory is supported to one where it
681 # is not.
682 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
683 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
684 rm -f $i/Makefile
685 done
687 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
688 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
689 rm -f ${target_subdir}/$i/Makefile
690 done
693 # Produce a warning message for the subdirs we can't configure.
694 # This isn't especially interesting in the Cygnus tree, but in the individual
695 # FSF releases, it's important to let people know when their machine isn't
696 # supported by the one or two programs in a package.
698 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
699 # If $appdirs is non-empty, at least one of those directories must still
700 # be configured, or we error out. (E.g., if the gas release supports a
701 # specified target in some subdirs but not the gas subdir, we shouldn't
702 # pretend that all is well.)
703 if [ -n "$appdirs" ]; then
704 for dir in $appdirs ; do
705 if [ -r $dir/Makefile.in ]; then
706 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
707 appdirs=""
708 break
710 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
711 appdirs=""
712 break
715 done
716 if [ -n "$appdirs" ]; then
717 echo "*** This configuration is not supported by this package." 1>&2
718 exit 1
721 # Okay, some application will build, or we don't care to check. Still
722 # notify of subdirs not getting built.
723 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
724 echo " ${notsupp}" 1>&2
725 echo " (Any other directories should still work fine.)" 1>&2
728 # Set with_gnu_as and with_gnu_ld as appropriate.
730 # This is done by determining whether or not the appropriate directory
731 # is available, and by checking whether or not specific configurations
732 # have requested that this magic not happen.
734 # The command line options always override the explicit settings in
735 # configure.in, and the settings in configure.in override this magic.
737 # If the default for a toolchain is to use GNU as and ld, and you don't
738 # want to do that, then you should use the --without-gnu-as and
739 # --without-gnu-ld options for the configure script.
741 if [ x${use_gnu_as} = x ] ; then
742 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
743 with_gnu_as=yes
744 withoptions="$withoptions --with-gnu-as"
748 if [ x${use_gnu_ld} = x ] ; then
749 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
750 with_gnu_ld=yes
751 withoptions="$withoptions --with-gnu-ld"
755 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
756 # can detect this case.
758 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
759 with_newlib=yes
760 withoptions="$withoptions --with-newlib"
763 if [ x${shared} = xyes ]; then
764 case "${target}" in
765 hppa*) target_makefile_frag=config/mt-papic ;;
766 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
767 powerpc*-*) target_makefile_frag=config/mt-ppcpic ;;
768 alpha-*-linux*) target_makefile_frag=config/mt-elfalphapic ;;
769 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
770 esac
773 # post-target:
775 # Make sure that the compiler is able to generate an executable. If it
776 # can't, we are probably in trouble. We don't care whether we can run the
777 # executable--we might be using a cross compiler--we only care whether it
778 # can be created. At this point the main configure script has set CC.
779 echo "int main () { return 0; }" > conftest.c
780 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
781 if [ $? = 0 ] && [ -s conftest ]; then
783 else
784 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
785 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
786 rm -f conftest*
787 exit 1
789 rm -f conftest*
791 # The Solaris /usr/ucb/cc compiler does not appear to work.
792 case "${host}" in
793 sparc-sun-solaris2*)
794 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
795 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
796 could_use=
797 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
798 if [ -d /opt/cygnus/bin ] ; then
799 if [ "$could_use" = "" ] ; then
800 could_use="/opt/cygnus/bin"
801 else
802 could_use="$could_use or /opt/cygnus/bin"
805 if [ "$could_use" = "" ] ; then
806 echo "Warning: compilation may fail because you're using"
807 echo "/usr/ucb/cc. You should change your PATH or CC "
808 echo "variable and rerun configure."
809 else
810 echo "Warning: compilation may fail because you're using"
811 echo "/usr/ucb/cc, when you should use the C compiler from"
812 echo "$could_use. You should change your"
813 echo "PATH or CC variable and rerun configure."
817 esac
819 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
820 # binutils tools will find libbfd.so.
821 if [ "${shared}" = "yes" ]; then
822 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
823 Makefile > Makefile.tem
824 rm -f Makefile
825 mv -f Makefile.tem Makefile
827 case "${host}" in
828 *-*-hpux*)
829 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
830 Makefile > Makefile.tem
831 rm -f Makefile
832 mv -f Makefile.tem Makefile
834 esac
837 # If we are building for a cygwin32 host, then set INSTALL_PROGRAM_ARGS to
838 # -x. This will cause programs to be installed with .exe extensions.
839 case "${host}" in
840 *-*-cygwin32*)
841 sed -e 's/^INSTALL_PROGRAM_ARGS[ ]*=.*$/INSTALL_PROGRAM_ARGS = -x/' \
842 Makefile > Makefile.tem
843 rm -f Makefile
844 mv -f Makefile.tem Makefile
846 esac
848 # Record target_configdirs and the configure arguments in Makefile.
849 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
850 targargs=`echo "${arguments}" | \
851 sed -e 's/--norecursion//' \
852 -e 's/--cache[a-z-]*=[^ ]*//' \
853 -e 's/--ho[a-z-]*=[^ ]*//' \
854 -e 's/--bu[a-z-]*=[^ ]*//' \
855 -e 's/--ta[a-z-]*=[^ ]*//'`
857 # Passing a --with-cross-host argument lets the target libraries know
858 # whether they are being built with a cross-compiler or being built
859 # native. However, it would be better to use other mechanisms to make the
860 # sorts of decisions they want to make on this basis. Please consider
861 # this option to be deprecated. FIXME.
862 if [ x${is_cross_compiler} = xyes ]; then
863 targargs="--with-cross-host=${host_alias} ${targargs}"
866 # Default to --enable-multilib.
867 if [ x${enable_multilib} = x ]; then
868 targargs="--enable-multilib ${targargs}"
871 targargs="--host=${target_alias} --build=${build_alias} ${targargs}"
872 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
873 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
874 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
875 Makefile > Makefile.tem
876 rm -f Makefile
877 mv -f Makefile.tem Makefile
880 # Local Variables:
881 # fill-column: 131
882 # End: